#! /usr/bin/env node
const { JavaCaller } = require("./java-caller");
const fse = require("fs-extra");
const path = require("path");

class JavaCallerCli {
    "use strict";

    javaCallerOptions;

    constructor(configFile) {
        configFile = configFile || "./java-caller-config.json";
        configFile = fse.existsSync(configFile) ? configFile : path.resolve(`${__dirname}/${configFile}`);
        // Use JSON file
        const options = fse.readJSONSync(configFile);
        // Default output is console with CLI
        if (options.output == null) {
            options.output = "console";
        }
        if (options.rootPath == null) {
            options.rootPath = __dirname;
        }
        this.javaCallerOptions = options;
    }

    async process(processArgv, runOptions = {}) {
        const java = new JavaCaller(this.javaCallerOptions);
        const args = [...processArgv];
        args.splice(0, 3);
        const { status } = await java.run(args, runOptions);
        process.exitCode = status;
    }
}

module.exports = { JavaCallerCli };
